#!/usr/bin/perl
#
# Script to post new configuration file programatically

use LWP::UserAgent;
use URI::URL;
use HTTP::Request::Common;

# load the args
my($server, $username, $password, $sendFile) = @ARGV;

# echo them back
# print "server=$server\nlogin=$username/$password\nfile=$sendFile\n";

if($#ARGV != 3) { die "Usage: $0 <server> <user> <password> <file>" }

# Create a User Agent to make our query
$ua = new LWP::UserAgent;
$ua->agent("Mozilla/0.1 " . $ua->agent);

# construct the request
$request = POST  "http://$username:$password\@$server/inmsf/Report?authenticate=basic&action=install",
    Content_Type => 'multipart/form-data',
    Accept => 'text/plain',
    Content => [ 'file' => [ $sendFile ] ];

# make the request
$response = $ua->request($request);

# check status
if (!$response->is_success) {
    print "Failed Request:  Error: " . $response->code . " " . $response->message . "\n";
    exit -1;
}

# silently exit 0 to indicate success (this may fail if the "loaded"
# string has been localized) otherwise just print what came back.
if ($response->content =~ /New Configuration loaded/) {
    exit 0;
}
else {
    print $response->content;
    exit 1;
}
