
\ endgroup must be defined above
\ queryType must be defined above

: numaNodes NumaNodesArray swap drop ;
: numaArray NumaNodesArray drop ;
: threadsPerNode numReaderThreads numaNodes / ?dup 0= IF 1 THEN ;
: totalReaderThreads numaNodes threadsPerNode * ;

numaNodes array Fifo_Jobs

: buildFifoArray
  numaNodes 0 DO
    jobFifoDepth FifoNew     \ new fifo
      Fifo_Jobs I cells + !  \ store in fifo array
  LOOP
;

buildFifoArray
variable Fifo_Results resultFifoDepth FifoNew Fifo_Results !
variable Fifo_Start 1 FifoNew Fifo_Start !

256 string INXTHREAD s" inxQueryThread" INXTHREAD place
256 string THREAD_FILE_FEED s" IntervalWalkQueryFileFeed " THREAD_FILE_FEED place
256 string THREAD_READER s" IntervalWalkQueryReader " THREAD_READER place

: setQueryType { walker -- } walker queryType IntervalWalkSetQueryType ;

: clearFifos
       Fifo_Results @ FifoClear
       numaNodes 0 DO
            Fifo_Jobs I cells + @ FifoClear
       LOOP
;

: startFileFeedThread
	INXTHREAD count
	Fifo_Start         \ InxFifo ** in_array
        1		   \ with one fifo
        0                  \ my input fifo index
	Fifo_Jobs          \ InxFifo ** out_array
        numaNodes          \ with this many fifos
        threadsPerNode     \ and this many readers behind each one
	THREAD_FILE_FEED count
	-1                   \ node id (ignored)
	NumaThreadFork drop
;


: runWalkSetQuery { walkSet -- }

        walkSet ['] setQueryType WalkSetDo

    	startFileFeedThread

        numaNodes 0 DO           
           threadsPerNode 0 DO                \ now I=nodeThread and J=numaNodeIdx
		INXTHREAD count
		Fifo_Jobs J cells +           \ InxFifo ** in_array for this numa node
                1                             \  with this many fifos
		0                             \ index of in fifo for this thread
		Fifo_Results                  \ InxFifo ** out_array
                1                             \ with 1 fifo
		1			      \ and 1 downstream thread behind it
		THREAD_READER count
		numaArray J cells + @         \ node id
		NumaThreadFork drop
           LOOP
	LOOP

       walkSet 0 0 ['] endGroup Fifo_Start @ Fifo_Results @ IntervalWalkQueryMaster

       walkset WalkSetPass2 IF
         clearFifos \ just in case FILEFEED_DONE was not consumed by master, for example
         startFileFeedThread
         walkSet 0 0 ['] endGroup Fifo_Start @ Fifo_Results @ IntervalWalkQueryMaster
       THEN
;

\ make sure there is a cr at the end