$(function() {
        var height = 140;
        var width = 500;
        var loading = true;
        var dataURL = $.inmon.dataURL || window.location.href;
	var dataUpdate = false;
	var refresh = 60000;
        var loading = true;
        var initialize = true;
	var cdata = {};
        var lang = $('html').attr("lang") || "en";

        function initCharts(data) {
           var ncols = data.columns;
           var html, i, chart, spec;
           html = '<div id="dashboard">';
           if(ncols > 1) {
             html += '<table><tbody><tr>';
             for(i = 0; i < data.charts.length; i++) {
               chart = data.charts[i];
               if(i > 0 && i % ncols == 0) html += '</tr><tr>';
               html += '<td class="padChart">';
               if(chart.title) html += '<h2>'+chart.title+'</h2>';
               html += '<div id="'+chart.id+'" class="trend"></div></td>';
             }
             html += '</tr></tbody></table>'; 
           } else if(ncols === 1) {
             for(i = 0; i < data.charts.length; i++) {
               chart = data.charts[i];
               html += '<div>';
               if(chart.title) html += '<h2>'+chart.title+'</h2>';
               html += '<div id="'+chart.id+'" class="trend" style="width:100%"></div>';
               html += '</div>';
             }
           } else {
             for(i = 0; i < data.charts.length; i++) {
               chart = data.charts[i];
               html += '<div class="floatChart">';
               if(chart.title) html += '<h2>'+chart.title+'</h2>';
               html += '<div id="'+chart.id+'" class="trend"></div>';
               html += '</div>';
             }
             html += '<div class="clearChart"></div>';
           }
           html += '</div>';
           $('#Q').html(html);
           for(i = 0; i < data.charts.length; i++) {
             chart = data.charts[i];
             $('#'+chart.id).chart(chart.spec,cdata[chart.id]);
           }
        }

	function updateData(data) {
            var i, chart;
            for(i = 0; i < data.charts.length; i++) {
              chart = data.charts[i];
              if(cdata[chart.id]) {
                 cdata[chart.id].trend.times = chart.trend.times;
                 cdata[chart.id].trend.trends = chart.trend.trends;
              }
              else cdata[chart.id] = chart;
              cdata[chart.id].trend.times = $.map(cdata[chart.id].trend.times,function(t) { return (new Date(t)).getTime(); });
            }
            if(loading) {
              $("#loading").empty().hide();
              $("#content").css("min-height","0");
              loading = false;
            }
            if(initialize) {
               initCharts(data); 
               initialize = false;
            }
	    $.event.trigger({type:'updateChart'});
	}
    
	function pollTrends() {
	    $.ajax({
		    dataType: "json",
		    url: dataURL,
		    data: { resultFormat: "json", lang:lang},
		    success: function(data) {
                        refresh = data.refresh;
			updateData(data);
			if(refresh) setTimeout(pollTrends, refresh);
		    },
		    error: function(result,status,errorThrown) {
			setTimeout(pollTrends,5000);
		    }
	     });
	};
    
	$(window).resize(function() {
		$.event.trigger({type:'updateChart'});
       });

	$(document).ready(function() {
            pollTrends();
	});
 });

