function Explorer(url,cdiv,zdiv,idiv,dMinX,dMaxX,dMinY,dMaxY,wMinX,wMaxX,wMinY,wMaxY) {
  this.startedX = 0;
  this.startedY = 0;

  this.stoppedX = 0;
  this.stoppedY = 0;

  this.currentX = 0;
  this.currentY = 0;

  this.dragging = false;  

  this.zoomURL = url;
  this.zoomGraphName = cdiv;
  this.zoomBoxName = zdiv;

  var div = document.getElementById(idiv);
  // find first image in this div
  this.imgObject = div.getElementsByTagName('img')[0];;

  this.zoomGraphLeft = 0;
  this.zoomGraphTop = 0;
  this.zoomGraphRight = 0;
  this.zoomGraphBottom = 0;
  this.zoomGraphWidth = 0;
  this.zoomGraphHeight = 0;

  this.zoomBoxLeft = 0;
  this.zoomBoxTop = 0;
  this.zoomBoxRight = 0;
  this.zoomBoxBottom = 0;
  this.zoomBoxWidth = 0;
  this.zoomBoxHeight = 0;

  this.zoomSensitiveZoneLeft = 0;
  this.zoomSensitiveZoneTop = 0;
  this.zoomSensitiveZoneRight = 0;
  this.zoomSensitiveZoneBottom = 0;
  this.zoomSensitiveZoneWith = 0;
  this.zoomSensitiveZoneHeight = 0;

  this.dMinX = dMinX;
  this.dMaxX = dMaxX;
  this.dMinY = dMinY;
  this.dMaxY = dMaxY;
  this.wMinX = wMinX;
  this.wMaxX = wMaxX;
  this.wMinY = wMinY;
  this.wMaxY = wMaxY;

  Explorer.instance = this;
}

Explorer.start = function() {
  if(Explorer.instance) {
     Explorer.instance.initEvents();
  }
  return true;
}

Explorer.stop = function() {
  if(Explorer.instance) {
     Explorer.instance.releaseEvents();
  }
  return true;
}

Explorer.refresh = function() {
  if(Explorer.instance) {
    Explorer.instance.refresh();
  }
  return true;
}

Explorer.getData = function(requestURL,msgID) {
  $.ajax({
    type: 'GET',
    url: requestURL,
    dataType: 'xml',
    success: function(data) { $("status",data).each(function(i) {
       var status = $(this);
       if(status.attr("complete") == 'true') {
          window.location = $(this).attr("url");
       }
       else {
          $("#" + msgID).html("<p></p>");
       }
    }); },
    error: function(xhr,desc,ex) { $("#" + msgID).html("<p>" + xhr.status + "</p>"); }
  });
}

Explorer.prototype.setEvent = function(theEvent) {
  if (theEvent) this.event = theEvent;
  else this.event = window.event;
}

Explorer.prototype.leftButtonPressed = function() {
  var pressed = false;
  if (this.event.which) pressed = this.event.which == 1;
  else if(this.event.button) pressed = this.event.button == 1;
  return pressed;
}

Explorer.prototype.rightButtonPressed = function() {
  var pressed = false;
  if (this.event.which) pressed = this.event.which == 3;
  else if (this.event.button) pressed = this.event.button == 2;
  return pressed;
}

Explorer.prototype.getCurrentPosition = function() {
  this.currentX = this.event.clientX + document.body.scrollLeft;
  this.currentY = this.event.clientY + document.body.scrollTop;
}

Explorer.prototype.saveCurrentToStartPosition = function() {
  this.startedX = this.currentX;
  this.startedY = this.currentY;
}

Explorer.prototype.saveCurrentToStopPosition = function() {
  this.stoppedX = this.currentX;
  this.stoppedY = this.currentY;
}

Explorer.prototype.refresh = function() {
  var cZoomBoxName = this.zoomGraphName;

  var cZoomSensitiveZoneName = this.zoomBoxName;
  var cZoomSensitiveZoneOffset = 30;

  var imgObject = this.imgObject;

  var width = imgObject.width;
  var height = imgObject.height;

  var zoomBoxWidth = this.dMaxX - this.dMinX;
  var zoomBoxHeight = this.dMaxY - this.dMinY;

  var left = 0;
  var top = 0;
  do {
    left += imgObject.offsetLeft;
    top += imgObject.offsetTop;
    imgObject = imgObject.offsetParent;
  } while(imgObject);

  this.zoomGraphLeft = left;
  this.zoomGraphTop = top;
  this.zoomGraphRight = left + width;
  this.zoomGraphBottom = top + height;
  this.zoomGraphWidth = width;
  this.zoomGraphHeight = height;

  this.zoomBoxRight = this.zoomGraphRight - (this.wMaxX - this.dMaxX);

  this.zoomBoxTop = this.zoomGraphTop + (this.dMinY - this.wMinY);

  this.zoomBoxLeft = this.zoomBoxRight - zoomBoxWidth;

  this.zoomBoxBottom = this.zoomBoxTop + zoomBoxHeight;

  this.zoomBoxWidth = zoomBoxWidth;
  this.zoomBoxHeight = zoomBoxHeight;

  this.drawSelection(0, 0, 0, 0); // reset selection

  var divObject = document.getElementById(cZoomBoxName);
  divObject.style.left = this.zoomBoxLeft + 'px';
  divObject.style.top = this.zoomBoxTop + 'px';
  divObject.style.width = this.zoomBoxWidth + 'px';
  divObject.style.height = this.zoomBoxHeight + 'px';

  this.zoomSensitiveZoneLeft = this.zoomBoxLeft - cZoomSensitiveZoneOffset;
  this.zoomSensitiveZoneTop = this.zoomBoxTop - cZoomSensitiveZoneOffset;
  this.zoomSensitiveZoneRight = this.zoomBoxRight + cZoomSensitiveZoneOffset;
  this.zoomSensitiveZoneBottom = this.zoomBoxBottom + cZoomSensitiveZoneOffset;
  this.zoomSensitiveZoneWidth = this.zoomSensitiveZoneRight - this.zoomSensitiveZoneLeft;
  this.zoomSensitiveZoneHeight = this.zoomSensitiveZoneBottom - this.zoomSensitiveZoneTop;

  divObject = document.getElementById(cZoomSensitiveZoneName);
  divObject.style.left = this.zoomSensitiveZoneLeft + 'px';
  divObject.style.top = this.zoomSensitiveZoneTop + 'px';
  divObject.style.width = this.zoomSensitiveZoneWidth + 'px';
  divObject.style.height = this.zoomSensitiveZoneHeight + 'px';
}

Explorer.prototype.drawSelection = function(x1, y1, x2, y2) {
  x1 = x1 - this.zoomBoxLeft;
  x2 = x2 - this.zoomBoxLeft;
  y1 = y1 - this.zoomBoxTop;
  y2 = y2 - this.zoomBoxTop;

  var minX = Math.min(x1, x2);
  var maxX = Math.max(x1, x2) + 1;
  var minY = 0;
  var maxY = this.zoomBoxHeight;

  var divObject = document.getElementById(this.zoomGraphName);
  divObject.style.clip ="rect(" + minY + "px " + maxX + "px " + maxY + "px " + minX + "px)";
}

Explorer.prototype.insideZoomBox = function() {
  var szLeft = this.zoomSensitiveZoneLeft;
  var szTop = this.zoomSensitiveZoneTop;
  var szRight = this.zoomSensitiveZoneRight;
  var szBottom = this.zoomSensitiveZoneBottom;

  var mpX = this.currentX;
  var mpY = this.currentY;

  return ((mpX >= szLeft) && (mpX <= szRight) && (mpY >= szTop) && (mpY <= szBottom));
}

Explorer.prototype.initEvents = function() {
  document.onmousemove = this.onMouseMoveEvent; 
  document.onmousedown = this.onMouseDownEvent; 
  document.onmouseup = this.onMouseUpEvent; 
  window.onresize = this.windowOnResizeEvent; 

  if (document.captureEvents) {
    document.captureEvents(Event.MOUSEMOVE);
    document.captureEvents(Event.MOUSEDOWN);
    document.captureEvents(Event.MOUSEUP);
  }
}

Explorer.prototype.releaseEvents = function() {
  document.onmousemove = null; 
  document.onmousedown = null; 
  document.onmouseup = null; 
  window.onresize = null; 

  if (document.releaseEvents) {
    document.releaseEvents(Event.MOUSEMOVE);
    document.releaseEvents(Event.MOUSEDOWN);
    document.releaseEvents(Event.MOUSEUP);
  }
}

Explorer.prototype.onMouseDownEvent = function(e) {
  var me = Explorer.instance;
  me.setEvent(e);
  me.getCurrentPosition();

  if (me.insideZoomBox()) {
    if ((me.leftButtonPressed()) && (!me.dragging)) {
      me.dragging = true;
      me.saveCurrentToStartPosition();
      me.drawSelection(this.currentX, this.currentY, this.currentX, this.currentY);
    }
  }
}

Explorer.prototype.onMouseMoveEvent = function(e) {
  var me = Explorer.instance;
  me.setEvent(e);
  if (me.dragging) {
    me.getCurrentPosition();
    me.drawSelection(me.startedX, me.startedY, me.currentX, me.currentY);
  }
}

Explorer.prototype.onMouseUpEvent = function(e) {
  var me = Explorer.instance;

  me.setEvent(e);

  if ((me.rightButtonPressed()) && (me.insideZoomBox())) {
    me.dragging = false;

    window.location = me.zoomURL + "&zoom=out";
  }

  if ((me.leftButtonPressed()) && (me.dragging)) {
    me.getCurrentPosition();
    me.saveCurrentToStopPosition();
    me.dragging = false;

    if (((me.startedX < me.zoomBoxLeft) && (me.stoppedX < me.zoomBoxLeft)) ||
	((me.startedX > me.zoomBoxRight) && (me.stoppedX > me.zoomBoxRight)) ||
	((me.startedY > me.zoomBoxBottom) && (me.stoppedY > me.zoomBoxBottom)) ||
	((me.startedY < me.zoomBoxTop) && (me.stoppedY < me.zoomBoxTop))) {
    }
    else {
      var x1 = me.startedX - me.zoomBoxLeft;
      var x2 = me.stoppedX - me.zoomBoxLeft;

      var y1 = me.startedY - me.zoomBoxTop;
      var y2 = me.stoppedY - me.zoomBoxTop;

      var minX = Math.min(x1, x2);
      var maxX = Math.max(x1, x2);
      var minY = Math.min(y1, y2);
      var maxY = Math.max(y1, y2);

      if (minX < 0) minX = 0;
      if (maxX > me.zoomBoxWidth) maxX = me.zoomBoxWidth;
      if (minY < 0) minY = 0;
      if (maxY > me.zoomBoxHeight) maxY = me.zoomBoxHeight;

      if ((minX != maxX) || (minY != maxY)) {
        window.location = me.zoomURL + "&zoom=in&start=" + (minX / me.zoomBoxWidth) + "&end=" + (maxX / me.zoomBoxWidth);
      }
    }
  }
}

Explorer.prototype.windowOnResizeEvent = function() {
  Explorer.instance.refresh();
}

Explorer.prototype.rubberband = function(url,cdiv,zdiv,idiv,dMinX,dMaxX,dMinY,dMaxY,wMinX,wMaxX,wMinY,wMaxY) {
  this.zoomURL = url;
  this.zoomGraphName = cdiv;
  this.zoomBoxName = zdiv;

  var div = document.getElementById(idiv);
  // find first image in this div
  this.imgObject = div.getElementsByTagName('img')[0];

  this.dMinX = dMinX;
  this.dMaxX = dMaxX;
  this.dMinY = dMinY;
  this.dMaxY = dMaxY;
  this.wMinX = wMinX;
  this.wMaxX = wMaxX;
  this.wMinY = wMinY;
  this.wMaxY = wMaxY;

  this.refresh();

  this.initEvents();
}

$(document).ready(function() {
  if(Explorer.instance) {
    $("select")
      .mousedown(function() { Explorer.stop(); })
      .mouseup(function() { Explorer.start();});
    Explorer.instance.refresh();
    Explorer.instance.initEvents();
  }
  else if(Explorer.url) {
    Explorer.getData(Explorer.url,Explorer.msg);
  }
});

