-----------------------------------------------------------------------
----- Copyright (C) InMon Corp. 2014 ALL RIGHTS RESERVED       --------
----- logging / debug utils                                    --------
-----------------------------------------------------------------------

local debugAgent = inx.pref("@Poll2DebugAgent") or inx.pref("@PollDebugAgent")

local logger = {}

function logger.backtrace()
   local level = 1
   while true do
      local info = debug.getinfo(level, "Sl")
      if not info then break end
      local indent = string.rep (" ", level)
      if info.what == "C" then   -- is a C function?
	 inx.log(0, indent .. level .. ": C function")
      else   -- a Lua function
	 inx.log(0, indent .. level .. ": " .. string.format("[%s]:%d", info.short_src, info.currentline))
      end
      level = level + 1
   end
end

local function myLog(level, mod, agent, msg)
   local ip = "<nil>"
   if(agent) then ip = agent.ip end
   if(msg == nil) then logger.backtrace() end
   inx.log(level, (mod or "<nil mod>") .. " (agent=" .. ip .. ") " .. (msg or "<nil msg>"))
end

function logger.log(mod, ag, msg) myLog(0, mod, ag, msg) end
function logger.log1(mod, ag, msg) myLog(1, mod, ag, msg) end
function logger.log2(mod, ag, msg) myLog(2, mod, ag, msg) end
function logger.log3(mod, ag, msg) myLog(3, mod, ag, msg) end
function logger.log4(mod, ag, msg) myLog(4, mod, ag, msg) end

function logger.dbg(mod, ag, msg)
   if(ag.debug) then myLog(0, mod, ag, msg) end
end

function logger.err(mod, ag, msg)
   myLog(mod, ag, "ERR: " .. (msg or "<nil msg>"))
end

return logger
