-----------------------------------------------------------------------
----- Copyright (C) InMon Corp. 2014 ALL RIGHTS RESERVED       --------
----- SNMP oid utils                                           --------
-----------------------------------------------------------------------

local oid = {}

-- left-match oid in list
function oid.objIdMatch(objId, oidList)
   if(oidList == nil) then return true end -- empty list always match
   for ii,oi in ipairs(oidList) do
      if(string.find(objId, oi, 1, true) == 1) then
	 return true
      end
   end
   return false
end

-- get last integer in the oid
function oid.oid_index(oi)
   local last
   for ss in string.gmatch(oi, "%d+") do
      last = ss
   end
   return tonumber(last)
end

-- oid as array of numbers
function oid.oid_array(oi)
   local fields = {}
   for ss in string.gmatch(oi, "%d+") do
      fields[#fields+1] = tonumber(ss)
   end
   return fields
end

-- utilities for extracting data from dotted-decimal byte arrays

function oid.mac_at(ot, ii)
   return string.format("%02x%02x%02x%02x%02x%02x", ot[ii], ot[ii+1], ot[ii+2], ot[ii+3], ot[ii+4], ot[ii+5])
end

function oid.ip_at(ot, ii)
   return string.format("%d.%d.%d.%d", ot[ii], ot[ii+1], ot[ii+2], ot[ii+3])
end

function oid.be32_at(ot, ii)
   return (inx.bitOP(ot[ii], "<", 24) +  inx.bitOP(ot[ii+1], "<", 16) + inx.bitOP(ot[ii+2], "<", 8) + ot[ii+3])
end

return oid
