-----------------------------------------------------------------------
----- Copyright (C) InMon Corp. 2014 ALL RIGHTS RESERVED       --------
----- Module to poll CPU and memory stats from Hewlett-Packard --------
----- ProCurve devices                                         --------
-----------------------------------------------------------------------

local measurement = require("measurement")
local logger = require("logger")
local state = require("state")

local mod = "HP_CpuMem"
local e_hp = "1.3.6.1.4.1.11."
local hp_mem_total = e_hp .. "2.14.11.5.1.1.2.1.1.1.5.1"
local hp_mem_used = e_hp .. "2.14.11.5.1.1.2.1.1.1.6.1"
local hp_cpu_pc = e_hp .. "2.14.11.5.1.9.6.1.0"

local function getCB(ip, err, mem_used, mem_total, cpu60)
   local agent = state.getAgent(ip)
   if(err) then
      logger.err(mod, agent, err)
   else
      logger.log1(mod, agent, "getCB normal termination, send processor sample")
      measurement.processor(ip, mem_total, mem_used, cpu60)
   end
   return true
end

return {
   mod = mod,
   objIds = { e_hp },
   oids = { hp_mem_used, hp_mem_total, hp_cpu_pc },
   getCB = getCB
}
