-----------------------------------------------------------------------
----- Copyright (C) InMon Corp. 2014 ALL RIGHTS RESERVED           ----
----- Module to poll CPU and memory stats from Brocade(TM) devices ----
-----------------------------------------------------------------------

local logger = require("logger")
local state = require("state")
local oid = require("oid")
local util = require("util")
local mod = "Brocade_LACP"
local lag_mod = require("pollLAG_Brocade")

local e_brocade = "1.3.6.1.4.1.1991."
local e_brocade_lacp = e_brocade .. "1.1.3.33.3.1.1."
local lacp_status = e_brocade_lacp .. "3"
local lacp_sysid = e_brocade_lacp .. "4"
local lacp_remote = e_brocade_lacp .. "6"

local function walkCB(ip, status, rowid, lacp_status, lacp_sysid, lacp_remote)
   if (status == nil) then
      local agent,st = state.getState(mod, ip)
      logger.dbg(mod, agent, "walkCB rowid=" .. rowid .. " lacp_status=" .. tostring(lacp_status) .. " lacp_sysid=" .. tostring(lacp_sysid) .. " lacp_remote=" + tostring(lacp_remote))
   end
   return true -- keep going
end

return {
   mod = mod,
   objIds = { e_brocade },
   oids = { lacp_status, lacp_sysid, lacp_remote },
   walkCB = walkCB
}
