-----------------------------------------------------------------------
----- Copyright (C) InMon Corp. 2014 ALL RIGHTS RESERVED       --------
----- Module to store agent state for pollers.                 -------
-----------------------------------------------------------------------
local debugAgent = inx.pref("@Poll2DebugAgent") or inx.pref("@PollDebugAgent")
local state = { agents = {} }

function state.getAgent(ip)
   local agent = state.agents[ip]
   if(agent == nil) then
      agent = {
      	    ip = ip,
	    modules = {},
            datasources = {},
	    debug= (ip == debugAgent)
      }
      state.agents[ip] = agent
   end
   return agent
end

function state.getState(mod, ip)
   local agent = state.getAgent(ip)
   agentModState = agent.modules[mod]
   if(agentModState == nil) then
      agentModState = {
        mod = mod,
        agent = agent,
        scheduled = false
      }
      agent.modules[mod] = agentModState
   end
   return agent,agentModState
end

local function getTableAt(tab, ii)
   if not tab[ii] then tab[ii] = {} end
   return tab[ii]
end

function state.getDataSource(ip, dsclass, dsindex)
   local agent = state.getAgent(ip)
   local dscls = tonumber(dsclass)
   local dsidx = tonumber(dsindex)
   local clstab = getTableAt(agent.datasources, dscls)
   local ds = getTableAt(clstab, dsidx)
   if not ds.seqNo then
     ds.seqNo = 1
     ds.samples = 0
   end
   return ds
end

return state
