// path-filter: nav.map:nav.map.l4

// create a dependency tree
// who depends on this host (clients)
// who provides services to this host (servers)

if(typeof(host) == 'undefined') throw("missing input_host");

var interval = typeof(date) != 'undefined' ? date : 'last60minutes';
var where = typeof(filter) != 'undefined' ? filter : null;

var category = 'serverport';
var value = 'rate(frames)';
var units = 'fps';
var truncate = 5;
var view = 'rttraffic';

var q = Query.topN('rttraffic','time,' + category + ',' + value,where,interval,value,truncate);
q.group = 'minute';
q.globaltruncate = true;
var trend = q.run();
if(trend) {
   if("bps" == units) trend.scaleColumn(2,8);
   var pivoted = trend.pivotTime(0,1,2,true);
   var chart = Chart.multiSeries('trend',null,pivoted,null,0,units,Chart.range(1,pivoted.ncols - 1));
   chart.stack=true;
   chart.width = 400;
   chart.height = 200;
   addresult(chart);
}
