// author: InMon
// date: 4/09/2013
// version: 1.0
// description: Time and result size restricted database query
// inputs: view,select,where,interval,sort,n,group
// ttl: 60
// resultFormat: json
// authClients: 127.0.0.1,::1

var view     = view     || "traffic";
var select   = select   || "sourceaddress,bytes";
var where    = where    || "";
var interval = interval || "last60minutes";
var sort     = sort     || "bytes";
var n        = n        || 10;
var group    = group    || "";

var max_n     = 100;
var max_range = 180;

var result = {};
try {
  if(n <= 0) throw "error n <= 0";
  if(n > max_n) throw "error n > " + max_n; 

  var q = Query.topN(view,select,where,interval,sort,n);
  q.group = group;

  var times = q.timeRange();
  var now = (new Date()).getTime();
  if((Math.abs((now - times[0].getTime()) / 60000)) > max_range) throw "interval range";
  if((Math.abs((now - times[1].getTime()) / 60000)) > max_range) throw "interval range"; 

  var data = {};
  data.rows = [];
  var table = q.run(function(row) {
     data.rows.push(row);
  });
  data.start = table.start;
  data.end = table.end;
  result.data = data;
  result.ok = true;
} catch(err) {
  result.ok=false;
  result.error = err;
}

println(JSON.stringify(result,null,1));
